#define LOG_TAG "iec61850"
#include "elog.h"
#include "common.h"
#include <stdlib.h>
#include "thread.h"
#include <pthread.h>
#include "msq.h"
#include "scl_shm.h"
#include "iec61850_process.h"

mqd_t iec61850_rx_mq;//
SCL_MSG_TYPE recv_iec_msg;
static char iec61850_rx_buf[1024];


int iec61850_send_msg(void *msg,int msg_len)
{
  static mqd_t iec61850_rx_slave_mq=(mqd_t)-1;
  if(iec61850_rx_slave_mq==-1)
   {
	 if((iec61850_rx_slave_mq= open_mq(IEC61850_RX_MQ))==((mqd_t)-1))
	    return -1;
   }
  if(mq_send(iec61850_rx_slave_mq,(const char *)msg,msg_len,IEC61850_RX_MQ_PRIO)==-1)
	 return -2;
 
  return 0;
}


int send_ysp_msg(void *svbr_pri,uint32_t len)
{
 static unsigned char sjzd_msg_buf[512];
 unsigned int cmd;
 cmd=CMD_SEND_PRI_DATA;
 memcpy(sjzd_msg_buf,&cmd,sizeof(cmd));
 memcpy(&sjzd_msg_buf[4],(const void *)svbr_pri,len);
 return iec61850_send_msg(sjzd_msg_buf,len+4);	
}


void *iec61850_rx_routine(void *arg)
{  
  int i;
  time_t now;
  LN_SVBR_TYPE ln_svbr;

  start_scl_mem();
  if((iec61850_rx_mq=create_mq(IEC61850_RX_MQ,IEC61850_RX_MAX_MESSAGE,IEC61850_RX_MESSAGE_SIZE))<0)
   {
   	 log_e("create iec61850 rx message queue failed\n");
   	 exit(1);
   }
   
  while(1)
   {
     if(recv_mq_wait(iec61850_rx_mq,(void *)iec61850_rx_buf,sizeof(iec61850_rx_buf),1000000)>0)
	    {
        memcpy(&recv_iec_msg,iec61850_rx_buf,sizeof(recv_iec_msg));        
        switch(recv_iec_msg.cmd)
        {
		       case CMD_SEND_PRI_DATA:
		          log_d("receive CMD_SEND_PRI_DATA\n");
			        now=time(NULL);
			        //lock_input_data();             
              //unlock_input_data();		 		    
			        lock_scl_mem();
              put_mv_data(0,0,(USR_MV *)&ln_svbr,sizeof(ln_svbr)/sizeof(USR_MV));
   	          unlock_scl_mem();	      
		          break;
    	     default:
    	        break;
        }
	    }
	   else
	    {
 	      now=time(NULL);
        //lock_input_data();      
        //unlock_input_data(); 	        	     
   	    lock_scl_mem();
        put_mv_data(0,0,(USR_MV *)&ln_svbr,sizeof(ln_svbr)/sizeof(USR_MV));     	     
   	    unlock_scl_mem();
      }
    }
  stop_scl_mem();
}


int iec61850_rx_init(void)
{
  pthread_t iec61850_rx_thread;
  if((iec61850_rx_thread=task_create(iec61850_rx_routine,NULL,0,0))==-1)
   {
	 log_e("create iec61850_rx_routine failed\n");
	 return 1;
   }
  return 0;
}
