#include "msq.h"
#include <sys/time.h>
/*
#define S_IRWXU 00700
#define S_IRUSR 00400
#define S_IWUSR 00200
#define S_IXUSR 00100

#define S_IRWXG 00070
#define S_IRGRP 00040
#define S_IWGRP 00020
#define S_IXGRP 00010
 
#define S_IRWXO 00007
#define S_IROTH 00004
#define S_IWOTH 00002
#define S_IXOTH 00001
#define MODE S_IRUSR|S_IWUSR|S_IRGRP|S_IWGRP
*/

#define MODE S_IRWXU|S_IRWXG|S_IRWXO
mqd_t create_mq(const char *mq_name,long int mq_maxmsg,long int mq_msgsize)
{
  mqd_t my_mq=(mqd_t)(-1);
  struct mq_attr my_attr;
  
  my_attr.mq_flags=0;
  my_attr.mq_maxmsg=mq_maxmsg;
  my_attr.mq_msgsize=mq_msgsize;
  my_mq=mq_open(mq_name,O_CREAT|O_RDONLY/*|O_NONBLOCK*/,MODE,&my_attr);
  return my_mq;	
}


mqd_t open_mq(const char *mq_name)
{    
  return mq_open(mq_name,O_WRONLY|O_NONBLOCK,0,NULL);	
}


//timeouts is in us
ssize_t recv_mq_wait(mqd_t mq,void *msg,int size,int timeouts)
{
  struct timespec timeout;
  struct timeval  now;
  ssize_t length;

  gettimeofday(&now,NULL);
  now.tv_usec+=timeouts;
  if(now.tv_usec>=1000000)
   {
     now.tv_sec+=(now.tv_usec/1000000);
     now.tv_usec=now.tv_usec%1000000;
   }
  timeout.tv_sec=now.tv_sec;
  timeout.tv_nsec= now.tv_usec*1000;
  length=mq_timedreceive(mq,(char*)msg,size,NULL,&timeout);
  return length;
}





